# QPSReader

A package to read linear optimization problems in MPS format and quadratic optimization problems in QPS format.

[![DOI](https://img.shields.io/badge/DOI-10.5281%2Fzenodo.3996203-blue.svg)](https://doi.org/10.5281/zenodo.3996203)
![CI](https://github.com/JuliaSmoothOptimizers/QPSReader.jl/workflows/CI/badge.svg?branch=main)
[![Build Status](https://api.cirrus-ci.com/github/JuliaSmoothOptimizers/QPSReader.jl.svg)](https://cirrus-ci.com/github/JuliaSmoothOptimizers/QPSReader.jl)
[![codecov.io](https://codecov.io/github/JuliaSmoothOptimizers/QPSReader.jl/coverage.svg?branch=main)](https://codecov.io/github/JuliaSmoothOptimizers/QPSReader.jl?branch=main)
[![Documentation/stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaSmoothOptimizers.github.io/QPSReader.jl/stable)
[![Documentation/dev](https://img.shields.io/badge/docs-latest-blue.svg)](https://JuliaSmoothOptimizers.github.io/QPSReader.jl/dev)

## How to Cite

If you use QPSReader.jl in your work, please cite using the format given in [CITATION.bib](https://github.com/JuliaSmoothOptimizers/QPSReader.jl/blob/main/CITATION.bib).

The problems represented by the QPS format have the form

<p align="center">
optimize &nbsp; c₀ + cᵀ x + ½ xᵀ Q x
&nbsp;&nbsp;
subject to &nbsp; L ≤ Ax ≤ U and ℓ ≤ x ≤ u,

</p>

where:
* "optimize" means either "minimize" or "maximize"
* `c₀` ∈ ℝ is a constant term, `c` ∈ ℝⁿ is the linear term, `Q = Qᵀ` is the *n×n* quadratic term,
* `A` is the *m×n* constraint matrix, `L`, `U` are constraint lower and upper bounds, respectively
* `ℓ`, `u` are variable lower and upper bounds, respectively

Mixed-integer problems are supported, but semi-continuous and semi-integer variables are not.

## Quick start

### Installation
```julia
julia> ]
pkg> add QPSReader
```

### Reading a file

This package exports the `QPSData` data type and the `readqps()` function.
Because MPS is a subset of QPS, the `readqps()` function accepts both formats.
Because the SIF is a superset of QPS, QPS problems implemented as SIF files (such as those from the Maros-Meszaros collection) are also supported.

Both fixed and free format are supported (see below for format conventions).
To read a problem from a file:
```julia
julia> qps = readqps("Q25FV47.QPS")  # Free MPS is used by default
julia> qps = readqps("Q25FV47.QPS", mpsformat=:fixed)  # uses fixed MPS format
julia> qps = readqps("Q25FV47.QPS", mpsformat=:free)   # uses free MPS format
```

`readqps` also accepts an `IO` object as the first argument.

By default, a number of messages may be logged while reading.
Log output can be suppressed as follows:
```julia
using QPSReader
using Logging

qps = with_logger(Logging.NullLogger()) do
    readqps("Q25FV47.QPS")
end
```

## Problem representation

The `QPSData` data type is defined as follows:

```julia
mutable struct QPSData
    nvar::Int                        # number of variables
    ncon::Int                        # number of constraints
    objsense::Symbol                 # :min, :max or :notset
    c0::Float64                      # constant term in objective
    c::Vector{Float64}               # linear term in objective

    # Quadratic objective, in COO format
    qrows::Vector{Int}
    qcols::Vector{Int}
    qvals::Vector{Float64}

    # Constraint matrix, in COO format
    arows::Vector{Int}
    acols::Vector{Int}
    avals::Vector{Float64}

    lcon::Vector{Float64}            # constraints lower bounds
    ucon::Vector{Float64}            # constraints upper bounds
    lvar::Vector{Float64}            # variables lower bounds
    uvar::Vector{Float64}            # variables upper bounds
    name::Union{Nothing, String}     # problem name
    objname::Union{Nothing, String}  # objective function name
    rhsname::Union{Nothing, String}  # Name of RHS field
    bndname::Union{Nothing, String}  # Name of BOUNDS field
    rngname::Union{Nothing, String}  # Name of RANGES field
    varnames::Vector{String}         # variable names, aka column names
    connames::Vector{String}         # constraint names, aka row names

    # name => index mapping for variables
    # Variables are indexed from 1 and onwards
    varindices::Dict{String, Int}

    # name => index mapping for constraints
    # Constraints are indexed from 1 and onwards
    # Recorded objective function has index 0
    # Rim objective rows have index -1
    conindices::Dict{String, Int}

    # Variable types
    #  `VTYPE_Continuous`      <--> continuous
    #  `VTYPE_Integer`         <--> integer
    #  `VTYPE_Binary`          <--> binary
    #  `VTYPE_SemiContinuous`  <--> semi-continuous (not supported)
    #  `VTYPE_SemiInteger`     <--> semi-integer (not supported)
    vartypes::Vector{VariableType}

    # Indicates the sense of each row:
    # `RTYPE_Objective`    <--> objective row (`'N'`)
    # `RTYPE_EqualTo`      <--> equality constraint (`'E'`)
    # `RTYPE_LessThan`     <--> less-than constraint (`'L'`)
    # `RTYPE_GreaterThan`  <--> greater-than constraint (`'G'`)
    contypes::Vector{RowType}
end
```
Rows and variables are indexed in the order in which they are read.
The matrix Q is zero when reading an MPS file.

## Conventions

The file formats supported by `QPSReader` are described here:
* [MPS file format](http://lpsolve.sourceforge.net/5.5/mps-format.htm)
* [QPS extension](https://doi.org/10.1080/10556789908805768)

The following conventions are enforced:

### Rim data

* Multiple objective rows
    * The first `N`-type row encountered in the `ROWS` section is recorded as the objective function, and its name is stored in `objname`.
    * If an additional `N`-type row is present, a `warning`-level log is displayed. Subsequent `N`-type rows are ignored.
    * Each time a rim objective row is encountered in the `COLUMNS` or `RHS` section, the corresponding coefficients are skipped, and an `error`-level log is displayed.

* Multiple RHS / Range / Bound fields
    * The second field of the first card in the `RHS` section determines the name of the right-hand side, which is stored in `rhsname`. Same goes for the `RANGES` and `BOUNDS` sections, with the corresponding names being stored in `rngname` and `bndname`, respectively.
    * Any card whose second field does not match the expected name is then ignored.
    A `warning`-level log is displayed at the first such occurence.
    * In addition, any line or individual coefficient that is ignored triggers an `error`-level log.

### Variable bounds

* Default bounds for variables are `[0, Inf)`, to exception of integer variables (see below).
* If multiple bounds are specified for a given variable, only the most recent bound is recorded.

### Integer variables

There are two ways of declaring integer variables:

* Through markers in the `COLUMNS` section.
* By specifying `BV`, `LI` or `UI` bounds in the `BOUNDS` section
* The convention for integer variable bounds in as follows:
    | Marker? | `BOUNDS` fields | Type | Bounds reported |
    |:--:|:--:|:--:|:--:|
    | Yes | - | Integer | `[0, 1]`
    | Yes | `BV` | Binary | `[0, 1]`
    | Yes | (`LI`, `l`) | Integer | `[l, Inf]`
    | Yes | (`UI`, `u`) with `u≥0` | Integer | `[0, u]`
    | Yes | (`UI`, `u`) with `u<0` | Integer | `[-Inf, u]`
    | Yes | (`LI`, `l`) + (`UI`, `u`) | Integer | `[l, u]`
    | No | `BV` | Binary | `[0, 1]`
    | No | (`LI`, `l`) | Integer | `[l, Inf]`
    | No | (`UI`, `u`) with `u≥0` | Integer | `[0, u]`
    | No | (`UI`, `u`) with `u<0` | Integer | `[-Inf, u]`
    | No | (`LI`, `l`) + (`UI`, `u`) | Integer | `[l, u]`

    The `LI`/`UI` can be replaced by `LO`/`UP` in the table above, with no impact on bounds. Only the integrality of variables are affected.
    For continuous variables, follow the second half of the table, and replace `LI`/`UI` by `LO`/`UP`.

### Errors

* A row (resp. column) name that was not declared in the `ROWS` (resp. `COLUMNS`) section, appears elsewhere in the file.
The only case where an error is not thrown is if said un-declared row or column appears in a rim line that is skipped.
* An `N`-type row appears in the `RANGES` section


## Problem Collections

* The Netlib LPs: [original Netlib site](http://www.netlib.org/lp) | [in SIF format](http://www.numerical.rl.ac.uk/cute/netlib.html) | [as tar files](http://users.clas.ufl.edu/hager/coap/format.html) (incl. preprocessed versions)
* the Kennington LPs: [original Netlib site](http://www.netlib.org/lp/data/kennington)
* infeasible Netlib LPs: [original Netlib site](http://www.netlib.org/lp/infeas)
* the Maros-Meszaros QPs: [in QPS format](http://www.doc.ic.ac.uk/~im/#DATA) | [in SIF format](https://bitbucket.org/optrove/maros-meszaros/wiki/Home)

Both the Netlib LP and Maros-Meszaros QP collections are provided as Julia artifacts (requires Julia 1.3).
This package exports the `fetch_netlib` and `fetch_mm` functions that return the path to the Netlib and Maros-Meszaros collections, repectively
```julia
using QPSReader

netlib_path = fetch_netlib()
mm_path = fetch_mm()
```

# Benchmark

## Benchmark testsets

Benchmarks are run on the [Netlib LP collection](http://www.numerical.rl.ac.uk/cute/netlib.html) and [Maros-Meszaros QP collection](http://www.doc.ic.ac.uk/~im/#DATA).
They consist of 114 LPs and 138 QPs, respectively.
Both collections are automatically downloaded through Julia's artifact system.

## Running the benchmark

Ensure that your current `Manifest.toml` points to the correct version of `QPSReader`. Otherwise, the most recent version will be installed.
```julia
Pkg.develop(PackageSpec(path=".."))
```

Then, run the benchmark as follows:
```julia
using PkgBenchmark
import QPSReader
res = benchmarkpkg(pathof(QPSReader));
export_markdown("results.md", res)
```

## Comparing two commits

To compare against the `main` branch
```julia
using PkgBenchmark

judgement = judge("..", "main")
export_markdown("judgement.md", judgement)
```

import QPSReader: MPSCard, FreeMPS, FixedMPS, read_card!

function test_parser(card::MPSCard)
  @testset "Comment line" begin
    test_parser_comment!(card)
  end

  @testset "Header line" begin
    test_parser_header!(card)
  end

  @testset "Regular line" begin
    test_parser_general!(card)
  end
end

function test_parser_comment!(card)
  read_card!(card, "* This line is a comment")
  @test card.iscomment
  @test !card.isheader
  @test card.nfields == 0

  return
end

function test_parser_header!(card)
  read_card!(card, "COLUMNS")
  @test !card.iscomment
  @test card.isheader
  @test card.nfields == 1
  @test card.f1 == "COLUMNS"

  read_card!(card, "NAME          QPexample")
  @test !card.iscomment
  @test card.isheader
  @test card.nfields == 2
  @test card.f1 == "NAME"
  @test card.f2 == "QPexample"

  return
end

function test_parser_general!(card)
  # 2 fields
  read_card!(card, " N  obj")
  @test !card.iscomment
  @test !card.isheader
  @test card.nfields == 2
  @test card.f1 == "N"
  @test card.f2 == "obj"
  # Same, but 3rd character is non-empty instead of 2nd
  read_card!(card, "  N obj")
  @test !card.iscomment
  @test !card.isheader
  @test card.nfields == 2
  @test card.f1 == "N"
  @test card.f2 == "obj"

  # 3 fields (1st fixed field empty)
  read_card!(card, "    rhs1       r1              -4.0")
  @test !card.iscomment
  @test !card.isheader
  @test card.nfields == 3
  @test card.f1 == "rhs1"
  @test card.f2 == "r1"
  @test card.f3 == "-4.0"

  # 4 fields (1st fixed field non-empty)
  read_card!(card, " UP  bnd1      c1               20.0")
  @test !card.iscomment
  @test !card.isheader
  @test card.nfields == 4
  @test card.f1 == "UP"
  @test card.f2 == "bnd1"
  @test card.f3 == "c1"
  @test card.f4 == "20.0"

  # 5 fields (1st fixed field empty)
  read_card!(card, "    c1        r1                2.0    r2               -1.0")
  @test !card.iscomment
  @test !card.isheader
  @test card.nfields == 5
  @test card.f1 == "c1"
  @test card.f2 == "r1"
  @test card.f3 == "2.0"
  @test card.f4 == "r2"
  @test card.f5 == "-1.0"
end

@testset "Line parser" begin
  @testset "Fixed" begin
    test_parser(MPSCard{FixedMPS}(0, false, false, 0, "", "", "", "", "", ""))
  end

  @testset "Free" begin
    test_parser(MPSCard{FreeMPS}(0, false, false, 0, "", "", "", "", "", ""))
  end
end

using Documenter, QPSReader

makedocs(
  modules = [QPSReader],
  doctest = true,
  # linkcheck = true,
  strict = true,
  format = Documenter.HTML(
    assets = ["assets/style.css"],
    prettyurls = get(ENV, "CI", nothing) == "true",
  ),
  sitename = "QPSReader.jl",
  pages = Any["Home" => "index.md", "Tutorial" => "tutorial.md", "Reference" => "reference.md"],
)

deploydocs(repo = "github.com/JuliaSmoothOptimizers/QPSReader.jl.git", devbranch = "main")

@testset "Integers" begin
  @testset "$format" for format in [:fixed, :free]
    milp = with_logger(Logging.NullLogger()) do
      readqps("dat/milp.mps", mpsformat = format)
    end

    @test milp.vartypes[1] == QPSReader.VTYPE_Continuous  # no marker
    @test milp.vartypes[2] == QPSReader.VTYPE_Integer  # marker + no bounds
    @test milp.vartypes[3] == QPSReader.VTYPE_Binary  # marker + binary bound
    @test milp.vartypes[4] == QPSReader.VTYPE_Integer  # marker + LI
    @test milp.vartypes[5] == QPSReader.VTYPE_Integer  # marker + UI (>0)
    @test milp.vartypes[6] == QPSReader.VTYPE_Integer  # marker + UI (<0)
    @test milp.vartypes[7] == QPSReader.VTYPE_Integer  # marker + LI + UI
    @test milp.vartypes[8] == QPSReader.VTYPE_Integer  # marker + LO
    @test milp.vartypes[9] == QPSReader.VTYPE_Integer  # marker + UP (>0)
    @test milp.vartypes[10] == QPSReader.VTYPE_Integer  # marker + UP (<0)
    @test milp.vartypes[11] == QPSReader.VTYPE_Integer  # marker + LO + UP
    @test milp.vartypes[12] == QPSReader.VTYPE_Binary  # no marker + BV
    @test milp.vartypes[13] == QPSReader.VTYPE_Integer  # no marker + LI
    @test milp.vartypes[14] == QPSReader.VTYPE_Integer  # no marker + UI (>0)
    @test milp.vartypes[15] == QPSReader.VTYPE_Integer  # no marker + UI (<0)
    @test milp.vartypes[16] == QPSReader.VTYPE_Integer  # no marker + LI + UI
    @test milp.vartypes[17] == QPSReader.VTYPE_Continuous  # no marker + UP (<0)

    # Test bounds values
    @test (milp.lvar[1], milp.uvar[1]) == (0.0, Inf)
    @test (milp.lvar[2], milp.uvar[2]) == (0.0, 1.0)
    @test (milp.lvar[3], milp.uvar[3]) == (0.0, 1.0)
    @test (milp.lvar[4], milp.uvar[4]) == (-4.0, Inf)
    @test (milp.lvar[5], milp.uvar[5]) == (0.0, 5.0)
    @test (milp.lvar[6], milp.uvar[6]) == (-Inf, -6.0)
    @test (milp.lvar[7], milp.uvar[7]) == (-7.0, 7.0)
    @test (milp.lvar[8], milp.uvar[8]) == (-8.0, Inf)
    @test (milp.lvar[9], milp.uvar[9]) == (0.0, 9.0)
    @test (milp.lvar[10], milp.uvar[10]) == (-Inf, -10.0)
    @test (milp.lvar[11], milp.uvar[11]) == (-11.0, 11.0)
    @test (milp.lvar[12], milp.uvar[12]) == (0.0, 1.0)
    @test (milp.lvar[13], milp.uvar[13]) == (-13.0, Inf)
    @test (milp.lvar[14], milp.uvar[14]) == (0.0, 14.0)
    @test (milp.lvar[15], milp.uvar[15]) == (-Inf, -15.0)
    @test (milp.lvar[16], milp.uvar[16]) == (-16.0, 16.0)
    @test (milp.lvar[17], milp.uvar[17]) == (-Inf, -17.0)
  end
end

# http://lpsolve.sourceforge.net/5.5/mps-format.htm
# https://doi.org/10.1080/10556789908805768

"""
    RowType

An Enum of possible row types.

* `RTYPE_Objective`: objective row (`'N'`)
* `RTYPE_EqualTo`: equality constraint (`'E'`)
* `RTYPE_LessThan`: less-than constraint (`'L'`)
* `RTYPE_GreaterThan`: greter-than constraint (`'G'`)
"""
@enum RowType begin
  RTYPE_Objective
  RTYPE_EqualTo
  RTYPE_LessThan
  RTYPE_GreaterThan
end

function row_type(rtype::String)
  if rtype == "E"
    return RTYPE_EqualTo
  elseif rtype == "L"
    return RTYPE_LessThan
  elseif rtype == "G"
    return RTYPE_GreaterThan
  elseif rtype == "N"
    return RTYPE_Objective
  else
    error("Unknown row type $rtype")
  end
end

"""
    VariableType

An Enum of possible variable types.

* `VTYPE_Marked`: marked integer (for internal use)
* `VTYPE_Continuous`: continuous variable
* `VTYPE_Binary`: binary variable
* `VTYPE_Integer`: integer variable
* `VTYPE_SemiContinuous`: semi-continuous variable
* `VTYPE_SemiInteger`: semi-integer variable
"""
@enum VariableType begin
  VTYPE_Marked
  VTYPE_Continuous
  VTYPE_Binary
  VTYPE_Integer
  VTYPE_SemiContinuous
  VTYPE_SemiInteger
end

mutable struct QPSData
  nvar::Int                        # number of variables
  ncon::Int                        # number of constraints
  objsense::Symbol                 # :min, :max or :notset
  c0::Float64                      # constant term in objective
  c::Vector{Float64}               # linear term in objective

  # Quadratic objective, in COO format
  qrows::Vector{Int}
  qcols::Vector{Int}
  qvals::Vector{Float64}

  # Constraint matrix, in COO format
  arows::Vector{Int}
  acols::Vector{Int}
  avals::Vector{Float64}

  lcon::Vector{Float64}            # constraints lower bounds
  ucon::Vector{Float64}            # constraints upper bounds
  lvar::Vector{Float64}            # variables lower bounds
  uvar::Vector{Float64}            # variables upper bounds

  name::Union{Nothing, String}     # problem name
  objname::Union{Nothing, String}  # objective function name
  rhsname::Union{Nothing, String}  # Name of RHS field
  bndname::Union{Nothing, String}  # Name of BOUNDS field
  rngname::Union{Nothing, String}  # Name of RANGES field
  varnames::Vector{String}         # variable names, aka column names
  connames::Vector{String}         # constraint names, aka row names

  # name => index mapping for variables
  # Variables are indexed from 1 and onwards
  varindices::Dict{String, Int}
  # name => index mapping for constraints
  # Constraints are indexed from 1 and onwards
  # Recorded objective function has index 0
  # Rim objective rows have index -1
  conindices::Dict{String, Int}

  # Variable types
  vartypes::Vector{VariableType}
  # Constraint types (senses)
  contypes::Vector{RowType}

  # Constructor
  QPSData() = new(
    0,
    0,
    :notset,
    0.0,
    Float64[],
    Int[],
    Int[],
    Float64[],
    Int[],
    Int[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    nothing,
    nothing,
    nothing,
    nothing,
    nothing,
    String[],
    String[],
    Dict{String, Int}(),
    Dict{String, Int}(),
    VariableType[],
    RowType[],
  )
end

abstract type MPSFormat end
struct FixedMPS <: MPSFormat end
struct FreeMPS <: MPSFormat end

"""
    MPSCard{Format}

Data structure for parsing a single line of an MPS file.
"""
mutable struct MPSCard{Format <: MPSFormat}
  nline::Int       # Line number
  iscomment::Bool  # Is this line a comment/empty line?
  isheader::Bool   # Is this line a section header?

  nfields::Int  # Number of fields that were read

  # MPS fields
  f1::String
  f2::String
  f3::String
  f4::String
  f5::String
  f6::String
end

# Section headers
# Additional sections may be added
# By convention, all sections should correspond to non-negative integers
const ENDATA = 0
const NAME = 1
const OBJSENSE = 2
const ROWS = 3
const COLUMNS = 4
const RHS = 5
const BOUNDS = 6
const RANGES = 7
const QUADOBJ = 8
const OBJECT_BOUND = 10

const SECTION_HEADERS = Dict{String, Int}(
  "ENDATA" => ENDATA,
  "NAME" => NAME,
  "OBJSENSE" => OBJSENSE,  # Free MPS only
  "ROWS" => ROWS,
  "COLUMNS" => COLUMNS,
  "RHS" => RHS,
  "BOUNDS" => BOUNDS,
  "RANGES" => RANGES,
  "QUADOBJ" => QUADOBJ,
  "QMATRIX" => QUADOBJ,
  "OBJECT BOUND" => OBJECT_BOUND,  # SIF only
)

"""
    section_header(s::String)

Return the section corresponding to `s`.

Throws an error if `s` is not a recognized section header.
"""
function section_header(s::String)
  sec = get(SECTION_HEADERS, s, -1)
  (sec >= 0) || error("Un-recognized section header: $s")

  return sec
end

"""
    read_card!(card::MPSCard{FixedMPS}, ln::String)

Read the fields in `ln` into `card`.
"""
function read_card!(card::MPSCard{FixedMPS}, ln::String)
  l = length(ln)
  if l == 0 || ln[1] == '*' || ln[1] == '&'
    # This line is an empty line, or it is a comment
    card.iscomment = true
    card.isheader = false
    card.nfields = 0

    return card
  end

  if !isspace(ln[1])
    # This line is a section header
    card.iscomment = false
    card.isheader = true
    card.nfields = 1

    # This only works for fixed MPS; free format is not supported yet
    s = split(ln)
    card.f1 = String(s[1])
    # Read name, if applicable
    if card.f1 == "NAME"
      card.f2 = String(strip(ln[15:end]))
      card.nfields = 2
    elseif card.f1 == "OBJECT"
      # Check that this is a "OBJECT BOUND" line
      if s[2] == "BOUND"
        card.f1 = "OBJECT BOUND"
      else
        error("Unrecognized section header: $ln")
      end
    end

    return card
  end

  # Regular card
  card.iscomment = false
  card.isheader = false

  # Read fields
  # First field
  if l >= 3
    card.f1 = strip(String(ln[2:3]))
    card.nfields = 1
  else
    error("Short line\n$ln")
  end

  # Second field
  if 5 <= l <= 12
    card.f2 = strip(String(ln[5:end]))
    card.nfields = 2
  elseif l >= 13
    card.f2 = strip(String(ln[5:12]))
    card.nfields = 2
  end

  # Third field
  if 15 <= l <= 22
    card.f3 = strip(String(ln[15:end]))
    card.nfields = 3
  elseif l >= 23
    card.f3 = strip(String(ln[15:22]))
    card.nfields = 3
  end

  # Fourth field
  if 25 <= l <= 36
    card.f4 = strip(String(ln[25:end]))
    card.nfields = 4
  elseif l >= 37
    card.f4 = strip(String(ln[25:36]))
    card.nfields = 4
  end

  # Fifth field
  if 40 <= l <= 47
    card.f5 = strip(String(ln[40:end]))
    card.nfields = 5
  elseif l >= 48
    card.f5 = strip(String(ln[40:47]))
    card.nfields = 5
  end

  # Sixth field
  if 50 <= l <= 61
    card.f6 = strip(String(ln[50:end]))
    card.nfields = 6
  elseif l >= 62
    card.f6 = strip(String(ln[50:61]))
    card.nfields = 6
  end

  # If first field was empty, shift all fields to the left
  if length(card.f1) == 0
    card.f1 = card.f2
    card.f2 = card.f3
    card.f3 = card.f4
    card.f4 = card.f5
    card.f5 = card.f6
    card.nfields -= 1
  end

  return card
end

"""
    read_card!(card::MPSCard{FreeMPS}, ln::String)

Read the fields in `ln` into `card`.
"""
function read_card!(card::MPSCard{FreeMPS}, ln::String)
  l = length(ln)
  if l == 0 || ln[1] == '*' || ln[1] == '&'
    # This line is an empty line, or it is a comment
    card.iscomment = true
    card.isheader = false
    card.nfields = 0

  elseif !isspace(ln[1])
    # This line is a section header
    card.iscomment = false
    card.isheader = true
    card.nfields = 1

    # Read section header
    s = split(ln)
    card.f1 = String(s[1])
    # Read name, if applicable
    if card.f1 == "NAME"
      card.f2 = length(s) >= 2 ? s[2] : ""
      card.nfields = 2
    elseif card.f1 == "OBJECT"
      if s[2] == "BOUND"
        # OBJECT BOUND line
        card.f1 = "OBJECT BOUND"
      else
        error("Unrecognized section header: $ln")
      end
    end

  else
    # Regular card
    card.iscomment = false
    card.isheader = false

    # Read fields
    s = split(ln)
    l = length(s)  # Total number of fields
    if l == 0
      # Empty line
      card.iscomment = true
      card.isheader = false
      card.nfields = 0
      return card
    end

    l <= 6 || error("Too many fields in line.\n$ln")
    card.nfields = l

    if l >= 1
      card.f1 = s[1]
    end

    if l >= 2
      card.f2 = s[2]
    end

    if l >= 3
      card.f3 = s[3]
    end

    if l >= 4
      card.f4 = s[4]
    end

    if l >= 5
      card.f5 = s[5]
    end

    if l >= 6
      card.f6 = s[6]
    end
  end

  return card
end

function read_objsense_line!(qps::QPSData, card::MPSCard)
  if card.f1 == "MIN"
    qps.objsense = :min
  elseif card.f1 == "MAX"
    qps.objsense = :max
  else
    error("Unrecognized objective sense: $(card.f1)")
  end
  return nothing
end

"""
    read_rows_line
"""
function read_rows_line!(qps::QPSData, card::MPSCard)
  # Sanity check
  card.nfields >= 2 || error("Line $(card.nline) contains only $(card.nfields) fields")

  rtype = row_type(card.f1)
  rowname = card.f2

  if rtype == RTYPE_Objective
    # Objective row
    if qps.objname === nothing
      # Record objective
      qps.objname = rowname
      qps.conindices[rowname] = 0
      @info "Using '$rowname' as objective (l. $(card.nline))"
    else
      # Record name but ignore input
      @warn "Detected rim objective row $rowname at line $(card.nline)"
      qps.conindices[rowname] = -1
    end

    return nothing
  end

  # Regular row
  ncon = qps.ncon + 1
  ridx = get!(qps.conindices, rowname, ncon)
  ridx == ncon || error("Duplicate row name $rowname at line $(card.nline)")
  qps.ncon += 1

  # Record row sense
  push!(qps.contypes, rtype)
  push!(qps.connames, rowname)

  # Populate default values for right-hand sides
  # TODO: it would be more efficient to allocate memory only once
  if rtype == RTYPE_EqualTo
    push!(qps.lcon, 0.0)
    push!(qps.ucon, 0.0)
  elseif rtype == RTYPE_GreaterThan
    push!(qps.lcon, 0.0)
    push!(qps.ucon, Inf)
  elseif rtype == RTYPE_LessThan
    push!(qps.lcon, -Inf)
    push!(qps.ucon, 0.0)
  end

  return nothing
end

function read_columns_line!(qps::QPSData, card::MPSCard; integer_section::Bool = false)
  # Sanity check
  card.nfields >= 3 || error("Line $(card.nline) contains only $(card.nfields) fields")

  varname = card.f1
  nvar = qps.nvar + 1
  # Get column index
  col = get!(qps.varindices, varname, nvar)
  if col == nvar
    # new variable
    qps.nvar += 1
    push!(qps.varnames, varname)
    push!(qps.c, 0.0)

    # Record variable type
    push!(qps.vartypes, (integer_section ? VTYPE_Marked : VTYPE_Continuous))

    # Populate default variable bounds
    push!(qps.lvar, NaN)
    push!(qps.uvar, NaN)
  end

  fun = card.f2
  val = parse(Float64, card.f3)

  row = get(qps.conindices, fun, -2)
  if row == 0
    # Objective
    qps.c[col] = val
  elseif row == -1
    # Rim objective, ignore this input
    @error "Ignoring coefficient ($fun, $varname) with value $val at line $(card.nline)"
  elseif row > 0
    # Record coefficient
    push!(qps.arows, row)
    push!(qps.acols, col)
    push!(qps.avals, val)
  else
    # This row was not declared
    error("Unknown row $fun at line $(card.nline)")
  end

  card.nfields >= 5 || return nothing

  # Read second par of the fields
  fun = card.f4
  val = parse(Float64, card.f5)

  row = get(qps.conindices, fun, -2)
  if row == 0
    # Objective
    qps.c[col] = val
  elseif row == -1
    # Rim objective, ignore this input
    @error "Ignoring coefficient ($fun, $varname) with value $val at line $(card.nline)"
  elseif row > 0
    # Record coefficient
    push!(qps.arows, row)
    push!(qps.acols, col)
    push!(qps.avals, val)
  else
    # This row was not declared
    error("Unknown row $fun at line $(card.nline)")
  end

  return nothing
end

function read_rhs_line!(qps::QPSData, card::MPSCard)
  # Sanity check
  card.nfields >= 3 || error("Line $(card.nline) contains only $(card.nfields) fields")

  rhs = card.f1
  if qps.rhsname === nothing
    # Record this as the RHS
    qps.rhsname = rhs
    @info "Using '$rhs' as RHS (l. $(card.nline))"
  elseif qps.rhsname != rhs
    # Rim RHS, ignore this line
    @error "Skipping line $(card.nline) with rim RHS $rhs"
    return nothing
  end

  fun = card.f2
  val = parse(Float64, card.f3)
  row = get(qps.conindices, fun, -2)
  if row == 0
    # Objective row
    qps.c0 = -val
  elseif row == -1
    # Rim objective, ignore this input
    @error "Ignoring RHS for rim objective $fun at line $(card.nline)"
  elseif row > 0
    rtype = qps.contypes[row]
    if rtype == RTYPE_EqualTo
      qps.lcon[row] = val
      qps.ucon[row] = val
    elseif rtype == RTYPE_LessThan
      qps.ucon[row] = val
    elseif rtype == RTYPE_GreaterThan
      qps.lcon[row] = val
    end
  else
    # This row was not declared
    error("Unknown row $fun.")
  end

  card.nfields >= 5 || return nothing

  fun = card.f4
  val = parse(Float64, card.f5)
  row = get(qps.conindices, fun, -2)
  if row == 0
    # Objective row
    qps.c0 = -val
  elseif row == -1
    # Rim objective, ignore this input
    @error "Ignoring RHS for rim objective $fun at line $(card.nline)"
  elseif row > 0
    rtype = qps.contypes[row]
    if rtype == RTYPE_EqualTo
      qps.lcon[row] = val
      qps.ucon[row] = val
    elseif rtype == RTYPE_LessThan
      qps.ucon[row] = val
    elseif rtype == RTYPE_GreaterThan
      qps.lcon[row] = val
    end
  else
    # This row was not declared
    error("Unknown row $fun")
  end

  return nothing
end

"""


```
row type       sign of r       h          u
----------------------------------------------
    G            + or -         b        b + |r|
    L            + or -       b - |r|      b
    E              +            b        b + |r|
    E              -          b - |r|      b
```
"""
function read_ranges_line!(qps::QPSData, card::MPSCard)
  # Sanity check
  card.nfields >= 3 || error("Line $(card.nline) contains only $(card.nfields) fields")

  rng = card.f1
  if qps.rngname === nothing
    # Record this as the RANGES
    qps.rngname = rng
    @info "Using '$rng' as RANGES (l. $(card.nline))"
  elseif qps.rngname != rng
    # Rim RANGES, ignore this line
    @error "Skipping line $(card.nline) with rim RANGES $rng"
    return nothing
  end

  rowname = card.f2
  val = parse(Float64, card.f3)
  row = get(qps.conindices, rowname, -2)
  if row == 0 || row == -1
    # Objective row
    error("Encountered objective row $rowname in RANGES section")
  elseif row > 0
    rtype = qps.contypes[row]
    if rtype == RTYPE_EqualTo
      if val >= 0.0
        qps.ucon[row] += val
      else
        qps.lcon[row] += val
      end
    elseif rtype == RTYPE_LessThan
      qps.lcon[row] = qps.ucon[row] - abs(val)
    elseif rtype == RTYPE_GreaterThan
      qps.ucon[row] = qps.lcon[row] + abs(val)
    end
  else
    # This row was not declared
    error("Unknown row $rowname.")
  end

  card.nfields >= 5 || return nothing

  rowname = card.f4
  val = parse(Float64, card.f5)
  row = get(qps.conindices, rowname, -2)
  if row == 0 || row == -1
    # Objective row
    error("Encountered objective row $rowname in RANGES section")
  elseif row > 0
    rtype = qps.contypes[row]
    if rtype == RTYPE_EqualTo
      if val >= 0.0
        qps.ucon[row] += val
      else
        qps.lcon[row] += val
      end
    elseif rtype == RTYPE_LessThan
      qps.lcon[row] = qps.ucon[row] - abs(val)
    elseif rtype == RTYPE_GreaterThan
      qps.ucon[row] = qps.lcon[row] + abs(val)
    end
  else
    # This row was not declared
    error("Unknown row $rowname.")
  end

  return nothing
end

function read_bounds_line!(qps::QPSData, card::MPSCard)
  # Sanity check
  card.nfields >= 3 || error("Line $(card.nline) contains only $(card.nfields) fields")

  bnd = card.f2
  if qps.bndname === nothing
    # Record this as the BOUNDS
    qps.bndname = bnd
    @info "Using '$bnd' as BOUNDS (l. $(card.nline))"
  elseif qps.bndname != bnd
    # Rim BOUNDS, ignore this line
    @error "Skipping line $(card.nline) with rim bound $bnd"
    return nothing
  end

  varname = card.f3
  col = get(qps.varindices, varname, 0)
  col > 0 || error("Unknown column $varname")

  btype = card.f1

  if btype == "FR"
    qps.lvar[col] = -Inf
    qps.uvar[col] = Inf
    return nothing
  elseif btype == "MI"
    qps.lvar[col] = -Inf
    return nothing
  elseif btype == "PL"
    qps.uvar[col] = Inf
    return nothing
  elseif btype == "BV"
    qps.vartypes[col] = VTYPE_Binary
    qps.lvar[col] = 0
    qps.uvar[col] = 1
    return nothing
  elseif btype == "SC"
    # TODO: warning?
    error("Semi-continuous variables are currently not supported")
    return nothing
  end

  card.nfields >= 4 || error("At least 4 fields are required for $btype bounds")
  val = parse(Float64, card.f4)

  if btype == "LO"
    qps.lvar[col] = val
  elseif btype == "UP"
    qps.uvar[col] = val
  elseif btype == "FX"
    qps.lvar[col] = val
    qps.uvar[col] = val
  elseif btype == "LI"
    # Integer variable
    qps.vartypes[col] = VTYPE_Integer
    qps.lvar[col] = val
  elseif btype == "UI"
    # Integer variable
    qps.vartypes[col] = VTYPE_Integer
    qps.uvar[col] = val
  end

  return nothing
end

function read_quadobj_line!(qps::QPSData, card::MPSCard)
  # Sanity check
  card.nfields >= 3 || error("Line $(card.nline) contains only $(card.nfields) fields")

  colname = card.f1
  rowname = card.f2
  val = parse(Float64, card.f3)

  col = get(qps.varindices, colname, 0)
  col > 0 || error("Unknown variable $colname")
  row = get(qps.varindices, rowname, 0)
  row > 0 || error("Unknown variable $rowname")

  push!(qps.qcols, col)
  push!(qps.qrows, row)
  push!(qps.qvals, val)

  return nothing
end

function readqps(filename::String; mpsformat::Symbol = :free)
  open(filename, "r") do qps
    return readqps(qps; mpsformat = mpsformat)
  end
end

function readqps(qps::IO; mpsformat::Symbol = :free)
  name_section_read = false
  objsense_section_read = false
  rows_section_read = false
  columns_section_read = false
  rhs_section_read = false
  bounds_section_read = false
  ranges_section_read = false
  quadobj_section_read = false
  endata_read = false

  integer_section = false

  sec = -1

  if mpsformat == :fixed
    Tf = FixedMPS
  elseif mpsformat == :free
    Tf = FreeMPS
  else
    error("Unsupported format: $mpsformat")
  end

  card = MPSCard{Tf}(0, false, false, 0, "", "", "", "", "", "")

  qpsdat = QPSData()

  seekstart(qps)
  while !eof(qps)
    line = readline(qps)
    read_card!(card, line)

    card.nline += 1

    card.iscomment && continue

    if card.isheader
      sec = section_header(card.f1)
      if sec == NAME
        name_section_read && error("more than one NAME section specified")
        qpsdat.name = card.f2
        name_section_read = true
        @info "Using '$(qpsdat.name)' as NAME (l. $(card.nline))"
      elseif sec == OBJSENSE
        objsense_section_read && error("more than one OBJSENSE section specified")
        objsense_section_read = true
      elseif sec == ROWS
        rows_section_read && error("more than one ROWS section specified")
        rows_section_read = true
      elseif sec == COLUMNS
        columns_section_read && error("more than one COLUMNS section specified")
        rows_section_read || error("ROWS section must come before COLUMNS section")
        columns_section_read = true
      elseif sec == RHS
        rhs_section_read && error("more than one RHS section specified")
        rows_section_read || error("ROWS section must come before RHS section")
        columns_section_read || error("COLUMNS section must come before RHS section")
        ranges_section_read && error("RHS section must come before RANGES section")
        rhs_section_read = true
      elseif sec == BOUNDS
        bounds_section_read && error("more than one BOUNDS section specified")
        columns_section_read || error("COLUMNS section must come before BOUNDS section")
        bounds_section_read = true
      elseif sec == RANGES
        rows_section_read || error("ROWS section must come before RHS section")
        columns_section_read || error("COLUMNS section must come before RHS section")
        ranges_section_read && error("more than one RANGES section specified")
        ranges_section_read = true
      elseif sec == QUADOBJ
        quadobj_section_read && error("more than one QUADOBJ section specified")
        columns_section_read || error("COLUMNS section must come before QUADOBJ section")
        quadobj_section_read = true
      elseif sec == ENDATA
        endata_read && error("more than one ENDATA section specified")
        endata_read = true
        break
      elseif sec == OBJECT_BOUND
        # Do nothing
      end
      continue
    end

    # Line is not a comment/empty line, nor a section header
    if sec == OBJSENSE
      # Parse objective sense
      read_objsense_line!(qpsdat, card)
    elseif sec == ROWS
      read_rows_line!(qpsdat, card)
    elseif sec == COLUMNS
      # Check if card is marker
      if card.f2 == "'MARKER'"
        if card.f3 == "'INTORG'"
          integer_section = true
        elseif card.f3 == "'INTEND'"
          integer_section = false
        else
          @error "Ignoring marker $(card.f3) at line $(card.nline)"
        end
        continue
      end
      read_columns_line!(qpsdat, card; integer_section = integer_section)
    elseif sec == RHS
      read_rhs_line!(qpsdat, card)
    elseif sec == BOUNDS
      read_bounds_line!(qpsdat, card)
    elseif sec == RANGES
      read_ranges_line!(qpsdat, card)
    elseif sec == QUADOBJ
      read_quadobj_line!(qpsdat, card)
    else
      error("Unexpected section $sec in line\n$line")
    end
  end

  endata_read || @error("reached end of file before ENDATA section")

  # Finalize variable bounds
  # All marked integer variables with no explicit bounds
  # are converted to Integer variables with bounds [0, 1]
  for (j, (vt, l, u)) in enumerate(zip(qpsdat.vartypes, qpsdat.lvar, qpsdat.uvar))
    if isnan(l) && isnan(u)
      # Set default bounds
      qpsdat.lvar[j] = 0.0
      qpsdat.uvar[j] = (vt == VTYPE_Marked) ? 1.0 : Inf
    elseif isnan(l) && !isnan(u)
      # Only an upper bound was specified
      # Set lower bound to zero, unless upper bound is negative
      if u < 0
        qpsdat.lvar[j] = -Inf
      else
        qpsdat.lvar[j] = 0.0
      end
    elseif !isnan(l) && isnan(u)
      # Only a lower bound was specified
      # Set default upper bound
      qpsdat.uvar[j] = Inf
    end

    # Set correct variable type
    if vt == VTYPE_Marked
      qpsdat.vartypes[j] = VTYPE_Integer
    end
  end

  return qpsdat
end

using Logging

using BenchmarkTools
const BT = BenchmarkTools

using QPSReader

const NETLIB_DIR = fetch_netlib()
const MAROS_DIR = fetch_mm()

const SUITE = BT.BenchmarkGroup()

SUITE["netlib"] = BT.BenchmarkGroup()
SUITE["maros"] = BT.BenchmarkGroup()

"""
    readqps_silent

Silent wrapper of `readqps` for benchmark use.
"""
function readqps_silent(args...; kwargs...)
  with_logger(Logging.NullLogger()) do
    readqps(args...; kwargs...)
  end
end

"""
    add_instances!(suite, dir)

Create a BenchmarkGroup comprising all instances listed in `dir`.

Each file is read first, and is excluded from the benchmark if an error is
    encountered during the reading. The list of all such files is displayed in a
    warning message before exiting the function, when applicable.
"""
function add_instances!(suite, dir)
  instances = readdir(dir)
  errored_instances = String[]

  for finst in instances
    fpath = joinpath(dir, finst)

    # All instance files should have .SIF extension
    finst[(end - 3):end] == ".SIF" || continue

    try
      # First try to read in free MPS format.
      # If fails, try with fixed MPS format
      # If fails again, discard instance
      try
        readqps_silent(fpath)
        suite[finst] = @benchmarkable(readqps_silent($fpath))
      catch err
        readqps_silent(fpath, mpsformat = :fixed)
        suite[finst] = @benchmarkable(readqps_silent($fpath, mpsformat = :fixed))
      end
    catch err
      # Exclude file from benchmark
      push!(errored_instances, finst)
      continue
    end
  end

  nerr = length(errored_instances)
  if nerr > 0
    @warn "Reader errored on the following $nerr files:\n$(errored_instances)"
  end

  return suite
end

add_instances!(SUITE["netlib"], NETLIB_DIR)
add_instances!(SUITE["maros"], MAROS_DIR)

# this exhaustive correctness check requires QuadraticModels and CUTEst

include("readqps.jl")
include("qpmodel.jl")

using CUTEst

using Printf
using Test

const mpsdir = "/Users/dpo/local/problems/netlib-lp/MPS"
const lpsifdir = "/Users/dpo/local/problems/netlib-lp/sif"

const qpsdir = "/Users/dpo/local/problems/QPDATA"
const qpsifdir = "/usr/local/opt/maros_meszaros/share/maros_meszaros"

const atol = 1.0e-8
const rtol = 1.0e-6

# skip the following problems for now, whose range constraints are transformed
# in a way seemingly inconsistent with the others
const toskip = ["BOEING1", "BOEING2", "NESM"]

function download_data_files()
  # download("http://clas.ufl.edu/users/hager/LPTest/MPS/MPS.tar.gz")
  download("ftp://ftp.numerical.rl.ac.uk/pub/cuter/netlib.tar.gz")
  download("https://bitbucket.org/optrove/maros-meszaros/get/9adfb5707b1e.zip")
end

function compare_with_cutest(qpmodel::QuadraticModel, model::CUTEstModel)
  x = ones(model.meta.nvar)
  x[1:2:end] .= -1.0
  f = obj(model, x)
  @test abs(f - obj(qpmodel, x)) ≤ atol + rtol * abs(f)

  g = grad(model, x)
  @test norm(g - grad(qpmodel, x)) ≤ atol + rtol * norm(g)

  H = hess(model, x)
  @test norm(H - hess(qpmodel, x)) ≤ atol + rtol * norm(H)

  J = jac(model, x)
  @test norm(J - jac(qpmodel, x)) ≤ atol + rtol * norm(J)

  # CUTEst rearranges constraint lower and upper bounds
  c_cutest = cons(model, x)
  c_qps = cons(qpmodel, x)

  # l ≤ Ax is transformed to 0 ≤ Ax - l
  c_qps[qpmodel.meta.jlow] -= qpmodel.meta.lcon[qpmodel.meta.jlow]

  # Ax ≤ u is transformed to Ax ≤ 0
  c_qps[qpmodel.meta.jupp] -= qpmodel.meta.ucon[qpmodel.meta.jupp]

  # Ax = b is transformed to Ax - b = 0
  c_qps[qpmodel.meta.jfix] -= qpmodel.meta.lcon[qpmodel.meta.jfix]

  # l ≤ Ax ≤ u is transformed to 0 ≤ Ax - l ≤ u - l
  c_qps[qpmodel.meta.jrng] -= qpmodel.meta.lcon[qpmodel.meta.jrng]

  @test norm(c_cutest - c_qps) ≤ atol + rtol * norm(c_cutest)

  finalize(model)
end

function scan_qps(qpsfolder, qpsiffolder)
  # check that we read all original QPS files
  problems = readdir(qpsfolder)
  @printf("%12s  %6s  %6s  %7s  %7s\n", "name", "nvar", "ncon", "nnzA", "nnzQ")
  for problem in problems
    qp = readqps(joinpath(qpsfolder, problem))
    @printf("%12s  %6d  %6d  %7d  %7d\n", qp.name, qp.nvar, qp.ncon, nnz(qp.A), nnz(qp.Q))

    # check that we can also read a SIF file
    # SIF files are the same as the QPS files but have blank lines and comments
    filename = split(basename(problem), ".")[1]
    siffile = joinpath(qpsiffolder, "$(filename).SIF")
    if uppercase(filename) in toskip
      @warn "skipping $filename"
      continue
    end
    if isfile(siffile)
      qpsif = readqps(joinpath(qpsiffolder, "$(filename).SIF"))
      @test qp.nvar == qpsif.nvar
      @test qp.ncon == qpsif.ncon
      @test qp.c0 == qpsif.c0
      @test all(qp.c .== qpsif.c)
      # @test all(qp.Q .== qpsif.Q)
      # @test all(qp.A .== qpsif.A)
      @test all(qp.lvar .== qpsif.lvar)
      @test all(qp.uvar .== qpsif.uvar)
      @test all(qp.lcon .== qpsif.lcon)
      @test all(qp.ucon .== qpsif.ucon)
      # @test qp.name == qpsif.name  # sometimes, the name differs
      @test all(qp.varnames .== qpsif.varnames)
      @test all(qp.connames .== qpsif.connames)

      # test that a QuadraticModel based on a QPS file matches the CUTEstModel
      qpmodel = QuadraticModel(qp)
      model = CUTEstModel(siffile, efirst = false, lfirst = false, lvfirst = false)
      compare_with_cutest(qpmodel, model)
    else
      @warn "$siffile not found"
    end
  end
end

scan_qps(qpsdir, qpsifdir)
scan_qps(mpsdir, lpsifdir)

using Test
using Logging

using QPSReader

if VERSION ≥ v"1.3"
  netlib_path = fetch_netlib()
  @test ispath(netlib_path)
  @test isfile(joinpath(netlib_path, "AFIRO.SIF"))
  mm_path = fetch_mm()
  @test ispath(mm_path)
  @test isfile(joinpath(mm_path, "AUG3D.SIF"))
end

include("parser.jl")
include("qp-example.jl")
include("rimdata.jl")
include("integers.jl")

module QPSReader

export QPSData, readqps

include("readqps.jl")

if VERSION ≥ v"1.3"
  using Pkg.Artifacts

  export fetch_netlib, fetch_mm

  "Return the path to the Netlib linear optimization test set."
  function fetch_netlib()
    artifact_toml = joinpath(@__DIR__, "..", "Artifacts.toml")
    ensure_artifact_installed("netliblp", artifact_toml)
    netliblp_hash = artifact_hash("netliblp", artifact_toml)
    @assert artifact_exists(netliblp_hash)
    return joinpath(artifact_path(netliblp_hash), "optrove-netlib-lp-f83996fca937")
  end

  "Return the path to the Maros-Meszaros quadratic optimization test set."
  function fetch_mm()
    artifact_toml = joinpath(@__DIR__, "..", "Artifacts.toml")
    ensure_artifact_installed("marosmeszaros", artifact_toml)
    mm_hash = artifact_hash("marosmeszaros", artifact_toml)
    @assert artifact_exists(mm_hash)
    return joinpath(artifact_path(mm_hash), "optrove-maros-meszaros-9adfb5707b1e")
  end
end

end # module

using SparseArrays

# this is the example on pages 3-5 of
# I. Maros and C. Meszaros, "A Repository of Convex Quadratic Programming Problems",
# Technical Report DOC 97/6, Department of Computing, Imperial College, London, UK, 1997
# http://www.doc.ic.ac.uk/rr2000/DTR97-6.pdf

@testset "QP example" begin
  @testset "format=$format use_io_interface=$use_io_interface" for format in [:fixed, :free],
    use_io_interface in [true, false]

    if use_io_interface
      input = IOBuffer(read(open("dat/qp-example.qps"), String))
    else
      input = "dat/qp-example.qps"
    end

    # Test logging
    # Note that logs won't display since they are captured by the test macro
    qp = @test_logs(
      # These logs must appear in exactly this order
      (:info, "Using 'QPexample' as NAME (l. 1)"),
      (:info, "Using 'obj' as objective (l. 3)"),
      (:info, "Using 'rhs1' as RHS (l. 12)"),
      (:info, "Using 'bnd1' as BOUNDS (l. 16)"),
      match_mode = :all,
      readqps(input, mpsformat = format)
    )

    @test qp.name == "QPexample"
    @test qp.objname == "obj"
    @test qp.rhsname == "rhs1"
    @test qp.bndname == "bnd1"
    @test qp.rngname === nothing

    @test qp.nvar == 2
    @test qp.ncon == 2
    @test qp.c0 == 4.0
    @test all(qp.c .== [1.5, -2.0])
    Q = sparse(qp.qrows, qp.qcols, qp.qvals, qp.nvar, qp.nvar)
    A = sparse(qp.arows, qp.acols, qp.avals, qp.ncon, qp.nvar)
    @test all(Matrix(Q) .== [8.0 0.0; 2.0 10.0])
    @test all(Matrix(A) .== [2.0 1.0; -1.0 2.0])
    @test all(qp.lcon .== [2.0, -Inf])
    @test all(qp.ucon .== [Inf, 6.0])
    @test all(qp.lvar .== [0.0, 0.0])
    @test all(qp.uvar .== [20.0, Inf])

    @test qp.connames == ["r1", "r2"]
    @test qp.varnames == ["c1", "c2"]
    @test qp.varindices["c1"] == 1
    @test qp.varindices["c2"] == 2
  end
end

@testset "Rim data" begin
  for format in [:fixed, :free]
    @testset "$format" begin
      @testset "Objective" begin
        qp = @test_logs(
          (:info, "Using 'RimObj' as NAME (l. 1)"),
          (:info, "Using 'obj1' as objective (l. 3)"),
          (:warn, "Detected rim objective row obj2 at line 4"),
          (:warn, "Detected rim objective row obj3 at line 7"),
          (:error, "Ignoring coefficient (obj2, c1) with value 2.2 at line 10"),
          (:error, "Ignoring coefficient (obj2, c2) with value -2.2 at line 12"),
          (:error, "Ignoring coefficient (obj3, c1) with value 2.3 at line 13"),
          (:error, "Ignoring coefficient (obj3, c2) with value -2.3 at line 14"),
          (:info, "Using 'rhs1' as RHS (l. 16)"),
          (:error, "Ignoring RHS for rim objective obj2 at line 16"),
          match_mode = :all,
          readqps("dat/rim_obj.qps")
        )

        @test qp.objname == "obj1"
        @test qp.conindices["obj1"] == 0
        @test qp.conindices["obj2"] == -1
        @test qp.conindices["obj3"] == -1

        @test qp.c0 == 4.1

        @test qp.c == [1.5, -2.1]
      end

      @testset "Columns" begin end

      @testset "QuadObj" begin end

      @testset "RHS" begin
        qp = @test_logs(
          # These logs should appear in exactly this order
          (:info, "Using 'RimRHS' as NAME (l. 1)"),
          (:info, "Using 'obj1' as objective (l. 3)"),
          (:info, "Using 'rhs1' as RHS (l. 12)"),
          (:error, "Skipping line 13 with rim RHS rhs2"),
          (:error, "Skipping line 15 with rim RHS rhs2"),
          (:error, "Skipping line 16 with rim RHS rhs3"),
          match_mode = :all,
          readqps("dat/rim_rhs.qps")
        )

        @test qp.rhsname == "rhs1"

        @test qp.c0 == 4.1

        @test qp.lcon == [2.0, -Inf]
        @test qp.ucon == [Inf, 6.0]
      end

      @testset "Range" begin
        qp = @test_logs(
          # These logs should appear in exactly this order
          (:info, "Using 'RimRANGES' as NAME (l. 1)"),
          (:info, "Using 'obj1' as objective (l. 3)"),
          (:info, "Using 'rhs1' as RHS (l. 12)"),
          (:info, "Using 'rng1' as RANGES (l. 15)"),
          (:error, "Skipping line 16 with rim RANGES rng2"),
          match_mode = :all,
          readqps("dat/rim_rng.qps")
        )

        @test qp.rngname == "rng1"

        @test qp.lcon == [2.0, 3.9]
        @test qp.ucon == [3.1, 6.0]
      end

      @testset "Bounds" begin
        qp = @test_logs(
          # These logs should appear in exactly this order
          (:info, "Using 'RimBOUNDS' as NAME (l. 1)"),
          (:info, "Using 'obj' as objective (l. 3)"),
          (:info, "Using 'bnd1' as BOUNDS (l. 12)"),
          (:error, "Skipping line 13 with rim bound bnd2"),
          (:error, "Skipping line 15 with rim bound bnd2"),
          match_mode = :all,
          readqps("dat/rim_bnd.qps")
        )

        @test qp.bndname == "bnd1"

        @test qp.lvar == [0.0, 1.0]
        @test qp.uvar == [20.0, Inf]
      end
    end  # testset
  end  # format loop
end  # RimData testset
